package com.jmrosengard.xmlbroker.broker;

import  com.jmrosengard.xmlbroker.deploy.DeployException;
import  com.jmrosengard.xmlbroker.soapipr.Method;
import  com.jmrosengard.xmlbroker.javaipr.JavaInterpreter;

/**
* Port is the low level representation of a service
* it is loaded with a <i>service interface</i> during
* deployment.
*/

public class Port{
 private Class service;
 private Object servant;
 private Method actualMtd;
 private JavaInterpreter ipr;

 /**
 * Loads the service interface
 */
 public void setService(String serviceName) throws DeployException{
  try{
   service=Class.forName(serviceName);
   if(! service.getInterfaces()[0].equals(com.jmrosengard.xmlbroker.deploy.XbService.class))
   throw new DeployException(serviceName+" does not extend XbService.");
  }
  catch(Exception e){
   throw new DeployException("Unable to load the service interface: "+serviceName);
  }
  ipr=new JavaInterpreter(service);
  actualMtd=ipr.buildMethod();
 }
 /**
 * Returns the service interface
 */
 public Class getService(){
  return service;
 }
 /**
 * Instantiate the servant
 */
 public void setServant(String servantName) throws DeployException{
  try{
   Class cls=Class.forName(servantName);
   servant=cls.newInstance();
  }
  catch(Exception e){
   throw new DeployException("Unable to instantiate servant: "+servantName);
  }
 }
 /**
 * Return an instance of the servant
 */
 public Object getServant(){
  return servant;
 }

 /**
 * Return the `actual' Method
 */
 public Method getActualMtd(){
  return actualMtd;
 }
 /**
 * Only for testing
 */
 public static void main(String[] a){
  Port p=new Port();
  try{
   p.setService("deployed.NtpService");
  }
  catch(Exception e){
   e.printStackTrace();
  }
 }
}