
package com.jmrosengard.xmlbroker.client;

import com.jmrosengard.xmlbroker.broker.HttpClient;
import com.jmrosengard.xmlbroker.broker.PortKey;
import com.jmrosengard.xmlbroker.broker.SoapReqException;
import com.jmrosengard.xmlbroker.javaipr.JavaInterpreter;
import com.jmrosengard.xmlbroker.soapipr.ReqMsg;
import com.jmrosengard.xmlbroker.soapipr.SoapInterpreter;
import com.jmrosengard.xmlbroker.soapipr.Method;
import com.jmrosengard.xmlbroker.soapipr.Parameter;
import java.io.*;
import java.util.*;

/**
* XMLbroker dynamic proxy
*/

 public class XbProxy{

 private Method actual;
 private ReqMsg req;
 private HttpClient http;

 public XbProxy(){
  Class service=null;
  try{
   service=Class.forName(
    System.getProperty("xmlbroker.serviceInterface"));
  }
  catch(ClassNotFoundException e){
   e.printStackTrace();
  }
  actual=(new JavaInterpreter(service)).buildMethod();
 }

 /**
 * Execute remote method-- the address of the remote
 * server, and the service name must be defined as the
 * system properties: <i>xmlbroker.serverHost</i> and
 * <i>xmlbroker.serviceName</i>
 */
 public ArrayList invokeService(ArrayList ins){
  String ser=System.getProperty("xmlbroker.serviceName");
  System.out.println("[XMLbroker] sending request for service: "+ser+" ...");
  StringWriter sw;
  PrintWriter pw=new PrintWriter(sw=new StringWriter());
  try{
   req=new ReqMsg(pw,actual.getName(),new PortKey(ser));
  }
  catch(SoapReqException e){
   e.printStackTrace();
  }
  req.setParams(ins);
  // build request SOAP message
  req.build();
  http=new HttpClient();
  // send HTTP request and get Response
  BufferedReader br=new BufferedReader(new StringReader(http.getHttpResource(
   System.getProperty("xmlbroker.serverHost"),ser,sw.toString())));
  Method method=(new SoapInterpreter(br)).parse();
  return method.getOutParams();
 }
 /**
 * Only for testing
 */
 public static void main(String[] a){
  System.out.println(((Parameter)new XbProxy().invokeService(
   new ArrayList()).get(0)).getValue().toString());
 }
}