package com.jmrosengard.xmlbroker.deploy;

import java.io.*;
import java.util.*;
import com.jmrosengard.xmlbroker.broker.Port;
import com.jmrosengard.xmlbroker.broker.PortKey;
import com.jmrosengard.xmlbroker.broker.PortRegistry;

/**
* Deploy a service (a.k.a. port) on XMLbroker
*/
public class DeployManager{
 private ResourceBundle res;
 private InputStream in;
 private PortRegistry reg;
 private Port port;

 public DeployManager(){
  reg=PortRegistry.getDefaultRegistry();
  port=new Port();
 }

 /**
 * Loads deployment file and registers the
 * services.
 */
 public void load(){
  try{
   in=new BufferedInputStream(new FileInputStream(
    System.getProperty("xmlbroker.home")+"/conf/service.conf"));
   res=new PropertyResourceBundle(in);
   port.setService(res.getString("xmlbroker.serviceInterface"));
   port.setServant(res.getString("xmlbroker.servant"));
   PortKey pk;
   reg.register(pk=new PortKey(res.getString("xmlbroker.serviceName")),port);
   System.out.println("[XMLbroker] Deployed service: "+pk);
  }
  catch(Exception e){
   e.printStackTrace();
  }
  finally{
   try{
    if(in!=null)in.close();
   }catch(Exception ex){}
  }
 }
}