package com.jmrosengard.xmlbroker.javaipr;

import java.util.*;
import com.jmrosengard.xmlbroker.soapipr.Mode;

/**
* parse the method name and generate a queue of
* Mode objects
*/

class ModeQueueBuilder{
 private String methodNameStr;
 private ArrayList modes;
 private String methodName;

 ModeQueueBuilder(String methodNameStr){
  this.methodNameStr=methodNameStr;
  modes=new ArrayList(5);
  try{
   parse();
  }
  catch(JavaIprException e){
   e.printStackTrace();
  }
 }

 /**
 * parse the method name string
 */
 void parse() throws JavaIprException{
  int len=methodNameStr.length();
  int tkLen=0;
  // extract method name
  int k=methodNameStr.indexOf("__");
  methodName=k==-1?methodNameStr:methodNameStr.substring(0,k);
  // extract parameter modes
  String[] tokens={Mode.IN_MARK,Mode.OUT_MARK};
  Mode[] modeTypes={new Mode(Mode.MODE_IN),new Mode(Mode.MODE_OUT)};
  try{
   for(int i=0,j=0;i<tokens.length;i++,j=0){
    tkLen=tokens[i].length();
    while(j!=-1 && j<len){
     j=methodNameStr.indexOf(tokens[i],j);
     if(j!=-1){
      modes.add(modeTypes[i]);
      j+=tkLen;
     }
    }
   }
  }
  catch(Exception e){
   throw new JavaIprException("invalid mode mark ordering");
  }
 }

 /**
 * Return ArrayList of Mode
 */
 public ArrayList getModes(){
  return modes;
 }

 /**
 * Return ArrayList of Mode
 */
 public String getMethodName(){
  return methodName;
 }
 /**
 * for testing only
 */
 public static void main(String[] args){
  System.out.println(new ModeQueueBuilder("foo__in__in__out").getMethodName());
 }
}
