package com.jmrosengard.xmlbroker.soapipr;

import com.jmrosengard.xmlbroker.deploy.XbString;

/**
* Defines a method parameter -- with a mode
* and value.
*/

public class Parameter{

 private Mode mode;
 private String name;
 /**
 * XbString is a mutable string
 */
 private XbString val;

 public Parameter(String name,Mode mode,XbString val){
  this.name=name;
  this.mode=mode;
  this.val=val;
 }

 public Parameter(String name,Mode mode){
  this.name=name;
  this.mode=mode;
 }

 public Parameter(Mode mode){
  this.mode=mode;
 }

 /**
 * Set the value of the parameter
 */
 public void setValue(XbString val){
  this.val=val;
 }

 /**
 * Return the value of the parameter
 */
 public XbString getValue(){
  return val;
 }

 /**
 * Return the passing mode of the parameter
 * (MODE_IN or MODE_OUT)
 */
 public Mode getMode(){
  return mode;
 }

  /**
 * Return the nem of  the parameter
 */
 public String getName(){
  return name;
 }

 /**
 * Return <tt>true</tt> if the parameter's
 * value is set.
 */
 public boolean isSet(){
  return val!=null;
 }
}
